package com.cf.imes.module.executor.service.plan;

import java.util.*;
import javax.validation.*;

import com.cf.imes.module.executor.controller.admin.order.vo.order.OrderRespVO;
import com.cf.imes.module.executor.controller.admin.plan.vo.*;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.module.executor.dal.dataobject.order.OrderDO;

/**
 * 生产单开料排单 Service 接口
 *
 * @author 晨丰科技
 */
public interface PlanService {

    /**
     * 创建生产单开料排单
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createPlan(@Valid PlanSaveReqVO createReqVO);

    /**
     * 更新生产单开料排单
     *
     * @param updateReqVO 更新信息
     */
    void updatePlan(@Valid PlanSaveReqVO updateReqVO);

    /**
     * 删除生产单开料排单
     *
     * @param id 编号
     */
    Boolean deletePlan(Long id);

    /**
     * 获得生产单开料排单
     *
     * @param id 编号
     * @return 生产单开料排单
     */
    PlanRespVO getPlan(Long id);

    /**
     * 获得生产单开料排单分页
     *
     * @param pageReqVO 分页查询
     * @return 生产单开料排单分页
     */
    PageResult<PlanRespVO> getPlanPage(PlanPageReqVO pageReqVO);


    PageResult<OrderRespVOCopy> getOrderPage(OrderPageReqVOCopy pageReqVO);

    List<PlatePage> getNotPlanPlateListPage(PlateReqPageVO pageVO);

    Boolean addPlate(AddPlateReq req);

    Boolean cancellation(Long id);

    PageResult<PlateResList> getPlateByPlanId(GetPlateByPlanIdVO vo);

    PageResult<OrderRespVO> getOrderByPlanId(PlanOrderPageReqVO pageReqVO);

    PageResult<PlanGoodsVO> getNotPlanGoodsListPageByOrderId( NotPlanGoodsListPageVO pageVO);

    Boolean setSort(List<SortVO> list);
}